/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... uvod do OOP (dynamicky se zvetsujici pole)
*/

#include "ChytrePole.h"
#include<iostream>

using namespace std;

ChytrePole::ChytrePole(const ChytrePole& x) : n(x.n), k(x.k)
{
	a = new float[k];
	for (int i = 0; i < n; i++)
		a[i] = x.a[i];
}

 ChytrePole& ChytrePole::operator= (const ChytrePole& x)
{
	int i;
	// kopiruji prvky
	for (i = 0; ((i < n) && (i < x.n)); i++)
		a[i] = x.a[i];
	// pridavam prvky na konec
	for (i = n; i < x.n; i++)
		pridejNaKonec(x.a[i]);

	return *this;
}

 float& ChytrePole::operator[] (int i) 
 {
	  if ((i < n) && (i >= 0))
		 return a[i];
	 throw 1;
 }
	 
ChytrePole::ChytrePole()
{
	a = new float[1];
	k = 1;
	n = 0;
}

ChytrePole::~ChytrePole()
{
	delete[] a;
}


/* vypis pole */
void ChytrePole::vypis()
{
	for (int i = 0; i < n; i++)
		cout << a[i] << " ";
	cout << endl;
}

/* Funkce prida prvek na konec jiz plneho dynamickeho pole
* a ... reference na strukturu s polem
* x ... vkladana hodnota
*/
void ChytrePole::pridejNaKonec(float x)
{
	if (k == n)
	{
		float *nove = new float[2 * k];
		for (int i = 0; i < n; i++)
			nove[i] = a[i];
		delete[] a;
		a = nove;
		k *= 2;
	}
	a[n] = x;
	n++;
}

/* Funkce smaze v dynamickm poli prvek na indexu i
* (nasledujici prvky posune o 1 index zpet)
*/
void ChytrePole::smazPrvek(int i)
{
	if (0 > i || i >= n)
		return; // throw (string)"pristup do pole mimo meze";
	for (; i < (n - 1); i++)
		a[i] = a[i + 1];
	n--;
}

